// ADRTestDlg.cpp : implementation file
//
// By: John Homppi March 11, 1999
// This is a sample application. Production versions will require
// additional exception handling code.

// This sample was developed using Visual C++ V5.0 with MFC.
// It has been tested using Windows NT and Windows 95

#include "stdafx.h"
#include "ADRTest.h"
#include "ADRTestDlg.h"
#include "ComPort.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
}; // end CAboutDlg

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
} // end CAboutDlg::CAboutDlg()

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
} // end CAboutDlg::DoDataExchange

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CADRTestDlg dialog

CADRTestDlg::CADRTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CADRTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CADRTestDlg)
	m_sResults = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
} // end CADRTestDlg::CADRTestDlg

void CADRTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CADRTestDlg)
	DDX_Text(pDX, IDC_RESULTS, m_sResults);
	//}}AFX_DATA_MAP
} // end CADRTestDlg::DoDataExchange

BEGIN_MESSAGE_MAP(CADRTestDlg, CDialog)
	//{{AFX_MSG_MAP(CADRTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_COM1, OnCom1)
	ON_BN_CLICKED(IDC_COM2, OnCom2)
	ON_BN_CLICKED(IDC_COM3, OnCom3)
	ON_BN_CLICKED(IDC_COM4, OnCom4)
	ON_BN_CLICKED(IDC_READ, OnRead)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CADRTestDlg message handlers

BOOL CADRTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
} // end CADRTestDlg::OnInitDialog

void CADRTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	} // end if
} // end CADRTestDlg::OnSysCommand

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CADRTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	} // endif
} // end CADRTestDlg::OnPaint

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CADRTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CADRTestDlg::OnCom1() 
{
	g_sComPort = "Com1";
	CButton* pButton = (CButton*)this->GetDlgItem(IDC_READ);
	pButton->EnableWindow(TRUE);
	
} // end CADRTestDlg::OnCom1

void CADRTestDlg::OnCom2() 
{
	g_sComPort = "Com2";
	CButton* pButton = (CButton*)this->GetDlgItem(IDC_READ);
	pButton->EnableWindow(TRUE);
	
} // end CADRTestDlg::OnCom2

void CADRTestDlg::OnCom3() 
{
	g_sComPort = "Com3";
	CButton* pButton = (CButton*)this->GetDlgItem(IDC_READ);
	pButton->EnableWindow(TRUE);
	
} // end CADRTestDlg::OnCom3

void CADRTestDlg::OnCom4() 
{
	g_sComPort = "Com4";
	CButton* pButton = (CButton*)this->GetDlgItem(IDC_READ);
	pButton->EnableWindow(TRUE);
	
} // end CADRTestDlg::OnCom4

//
// user wants to read from the com port
//
void CADRTestDlg::OnRead() 
{
	CComPort* pComPort = new CComPort(g_sComPort);
	if (pComPort->Initialize())
	{
		pComPort->Read(m_sResults);
		pComPort->Terminate();
	}
	else
	{
		m_sResults = "Setup failed";
	} // end if
	UpdateData(FALSE); // push values out onto the screen
	
} // end CADRTestDlg::OnRead
